HDU 5984(求木棒切割期望 数学)

题意是给定一长为 L 的木棒,每次任意切去一部分直到剩余部分的长度不超过 D,求切割次数的期望。

若木棒初始长度不超过 D,则期望是 0.000000;

设切割长度为 X 的木棒切割次数的期望是 F(X).

则 F(X) = F(切割点位置为 0 ~ D) + F(切割点位置为 D ~ X ) + 1;(此处的 +1 是指首次切割产生的次数)

而 F(切割点位置为 0 ~ D ) = 0;(因为已无需再切割)

令下一次切割点的位置为 T,

F(切割点位置为 D ~ X ) = 在D~X上积分 ( 1 / X ) * F( T ) dT ;(在长度为 X 的木棒上选择到任何一点切割的概率为 1 / X)

F( X ) = F(切割点位置为 0 ~ D) + F(切割点位置为 D ~ X ) + 1 = 0 + 在D~X上积分 ( 1 / X ) * F( T ) dT + 1

两边求导:F‘( X ) = - ( 1 / X² ) * ∫ F( T ) dT + F( X ) / X;(积分区间均为 D ~ X)

又: F( X ) = ∫ ( 1 / X ) * F( T ) dT + 1

得:  - ( 1 / X² ) * ∫ F( T ) dT = ∫ ( 1 / X ) * F( T ) dT / ( -1 / X ) = ( F(X) - 1 ) / ( -1 / X )

则: F’( X ) = - ( 1 / X² ) * ∫ F( T ) dT + F( X ) / X = ( F(X) - 1 ) / ( -1 / X ) + F( X ) / X = 1 / X

即: F( X ) = ln( X ) + C ( C为常数 )

由 F( D ) = 1,得:C = 1 - ln( D )

得:F( L ) = ln( L ) + 1 - ln( D ) = log( L / D )  + 1.

代码如下:

 1 #include <bits/stdc++.h>
 2 using namespace std;
 3 int main()
 4 {
 5     int t;
 6     double l,d;
 7     scanf("%d",&t);
 8     while(t--)
 9     {
10         scanf("%lf%lf",&l,&d);
11         if(l<=d) puts("0.000000");
12         else printf("%.6lf\n",log(l/d)+1);
13     }
14     return 0;
15 }

感谢这些博客的作者:

https://blog.csdn.net/jay__bryant/article/details/81188557

https://blog.csdn.net/blue_skyrim/article/details/53262572

https://www.cnblogs.com/Yumesenya/p/7657820.html

原文地址:https://www.cnblogs.com/Taskr212/p/9740728.html

时间: 2024-10-08 01:29:02

HDU 5984(求木棒切割期望 数学)的相关文章

Pocky HDU 5984(几何概型-期望)

原题 链接 解析 设函数f(x)表示长度为x的棒截断次数的期望值. (1) 明显当x<=d时,f(x)=0; (2) 当f(x)>d时,f(x)=1+f(0~d)+f(d~x). 1表示必定要截断一次,f(0~d)表示截断一次后剩下0~d长度时的期望值,f(d~x)表示截断一次后剩下d~x长度时的期望值. 由(1)知,f(0~d)=0,关键在于求f(d~x),在长度为x的棒上截断一次,截断概率均为1/x,因此f(d~x)=(1/x)*∫(x,d)f(x)dx. 有f(x)=1+(1/x)*∫(

hdu 4803 Poor Warehouse Keeper(贪心+数学)

题目链接:hdu 4803 Poor Warehouse Keeper 题目大意:有以个屏幕可以显示两个值,一个是数量x,一个是总价y.有两种操作,一种是加一次总价,变成x,x+y:一种是加一个数量,这要的话总价也会相应加上一个的价钱,变成x+1,y+y/x.总价显示的为取整后的整数,小数部分忽略.给定一个目标x,y,初始状态为1,1,求最少需要多少次可以目标状态,不可以达到的话输出-1. 解题思路:如果是加一次总价的话,单价就在变大:如果是加一次数量的话,单价是不变的.总而言之,单价是只会往上

HDU 4006 求第k大数 treap

裸题,瞬秒.. #include <stdio.h> #include <iostream> #include <algorithm> #include <math.h> #include <vector> #include <set> #include <map> #include <queue> using namespace std; #define L(id) tree[id].ch[0] #defin

hdu 5621 KK&#39;s Point(数学,推理题)

题解: 在圆上点三个点时,除圆上三个交点外,圆内没有交点:在圆上点四个点时,除圆上四个交点外,圆内出现了一个交点,因此,在N个点中每四个点便可以在圆内产生一个交点,因此N个点在圆内形成的点的个数为CN4,总的交点数就是CN4+N 1 #pragma comment(linker, "/STACK:1024000000,1024000000") 2 #include<iostream> 3 #include<cstdio> 4 #include<cstrin

hdu 5344 MZL&#39;s xor(数学之异或)

Problem Description MZL loves xor very much.Now he gets an array A.The length of A is n.He wants to know the xor of all (Ai+Aj)(1≤i,j≤n) The xor of an array B is defined as B1 xor B2...xor Bn Input Multiple test cases, the first line contains an inte

HDU多校赛第9场 HDU 4965Fast Matrix Calculation【矩阵运算+数学小知识】

难度上,,,确实,,,不算难 问题是有个矩阵运算的优化 题目是说给个N*K的矩阵A给个K*N的矩阵B(1<=N<=1000 && 1=<K<=6),先把他们乘起来乘为C矩阵,然后算C^(N*N) 相当于 ABABABABABABAB...=(AB)^(N*N) 不如 A(BA)^(N*N-1)B 因为BA乘得K*K的矩阵,K是比较小的 #include <cstdio> #include <cstdlib> #include <cstr

HDU 2485 求删最少点使得 边权=1的有向图最短路&gt;k

题意: 给定n个点 m条有向边 k 下面m条有向边 问删最少几个点使得1-n的最短路>k 10 11 5 1 2 2 3 3 4 4 5 5 10 2 9 1 6 6 7 7 8 8 9 9 10 8 10 5 1 2 2 3 3 4 4 5 5 6 6 8 1 7 7 8 4 7 7 4 #include <stdio.h> #include <string.h> #define N 55 #define INF 1<<30 #define eps 1e-5 i

HDU 5570 balls 期望 数学

balls Time Limit: 20 Sec Memory Limit: 256 MB 题目连接 http://acm.hdu.edu.cn/showproblem.php?pid=5570 Description There are n balls with m colors. The possibility of that the color of the i-th ball is color j is ai,jai,1+ai,2+...+ai,m. If the number of b

HDU 3132 Taunt Exposure Estimation(数学)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3132 Problem Description The brave knights  of Camelot are constantly exposed to French taunting while assaulting the castle occupied by the French. Consequently, the taunting to which they are exposed v